' ------------------------------------------------------------------------------
'                      TEST NOKIA6100
' ------------------------------------------------------------------------------
/*
Connections
LCD_CS           PORTB4
LCD_CLK          PORTB7
LCD_DATA         PORTB5
LCD_RESET        PORTB1
LCD_BACKLIGHT    +5V
*/

$lib "lcd-pcf8833.lbx"
$regfile = "m32def.dat"
$crystal = 16000000
$hwstack = 32
$swstack = 8
$framesize = 24
Config Graphlcd = Color , Controlport = Portb , Cs = 4 , Rs = 1 , Scl = 7 , Sda = 5


Const Blue = &B00000011
Const Yellow = &B11111100
Const Red = &B11100000
Const Green = &B00011100
Const Black = &B00000000
Const White = &B11111111
Const Brightgreen = &B00111110
Const Lightgreen = &B01111100
Const Darkgreen = &B00010100
Const Darkred = &B10100000
Const Darkblue = &B00000010
Const Brightblue = &B00011111
Const Orange = &B11111000


Glcdcmd &H36                                                'memory access control - odwrocenie
Glcddata &HD0                                               'Dol Do Joystika
Glcdcmd &H25                                                'Set Contrast
Glcddata 73
Glcdcmd &HBF
Glcdcmd &H29                                                'Display On


Cls
Setfont Color16x16
Lcdat 10 , 2 , "AND-TECH" , Green , White
Setfont Color8x8
Lcdat 30 , 2 , "AND-GRAPH132" , Red , White
Box(0 , 80) -(132 , 90) , Red

End
$include "color16x16.font"
$include "color8x8.font"
