'Program zosta nadesany przez uytkownika piotr94
/*
Connections
LCD_CS           PORTC4
LCD_CLK          PORTC7
LCD_DATA         PORTC5
LCD_RESET        PORTC1
LCD_BACKLIGHT    +5V
*/

$lib "lcd-pcf8833.lbx"
$regfile = "m1280def.dat"
$crystal = 11059200

Config Graphlcd = Color , Controlport = Portc , Cs = 4 , Rs = 1 , Scl = 7 , Sda = 5

Const Blue = &B00000011
Const Yellow = &B11111100
Const Red = &B11100000
Const Green = &B00011100
Const Black = &B00000000
Const White = &B11111111
Const Brightgreen = &B00111110
Const Lightgreen = &B01111100
Const Darkgreen = &B00010100
Const Darkred = &B10100000
Const Darkblue = &B00000010
Const Brightblue = &B00011111
Const Orange = &B11111000

Glcdcmd &H25                                                'Ustawienie kontrastu
Glcddata 50                                                 'tu podajemy warto kontrastu, zwykle dziaa dobrze przy okoo 40-70
Glcdcmd &HBF

Glcdcmd &H36                                                'wchodzimy w sutawienia pamici
Glcddata &B10001000                                         'tu adujemy konfiguracj (tryb kolorw, orientacj, odbicie lustrzane,...) u mnie dziaa taka konfiguracja (efekt: poprawne kolory, d wywietlacza przy joysticku) jeli by co nie dziaao to sprbujcie sami pozmienia poszczeglne bity tej komendy (kady bit jest odpowiedzialny za inny parametr) sprawdzenie eksperymentalnie 8 bitw nie powinno sprawi problemu, a kady wywietlacz ma inne kaprysy (np. kod ze strony na ktrej si opieraem powodowa u mnie odbicie lustrzane, a u osoby z ktrej pracy korzystaem byo wszystko ok)
Glcdcmd &H21                                                'Inversion_on
'Glcdcmd &H20                                                'Inversion_off
'dwie powysze komendy (wystarczy odkomentowa odpowiedni) s odpowiedzialne z tryb negatywu (inwersji kolorw) jeli kolory s u was odwrcone to po prostu uyjcie tej drugiej komendy, jeli dalej nie ma efektw poeksperymentujcie z poprzedni komend
Glcdcmd &H29                                                'Teraz wczamy wywietlacz

'tutaj waciwa obsuga wywietlacza (wywietlanie tekstu itp.)

Mam nadziej, e komu pomoe.
Poniej umieszczam kod rdowy programu do testw wraz z joystickiem (Joystick-AD0 podpinany do kanau 0 ADC, wywietlacz wg. konfiguracji, inne parametry mona zmienia na staych na pocztku programu. ycz miej zabawy ;-)
Kod:

' ------------------------------------------------------------------------------
'                      TEST NOKIA6100
' ------------------------------------------------------------------------------
$lib "lcd-pcf8833.lbx"
$regfile = "m1280def.dat"
$crystal = 11059200
'$hwstack = 32
'$swstack = 8
'$framesize = 24

Const J_channel = 0
Const J_none = 1
Const J_up = 2
Const J_down = 3
Const J_right = 4
Const J_left = 5
Const J_press = 6

Declare Function Joystick()as Byte

Config Graphlcd = Color , Controlport = Portc , Cs = 4 , Rs = 1 , Scl = 7 , Sda = 5

Config Adc = Single , Prescaler = Auto , Reference = Off
Start Adc

Const Blue = &B00000011
Const Yellow = &B11111100
Const Red = &B11100000
Const Green = &B00011100
Const Black = &B00000000
Const White = &B11111111
Const Brightgreen = &B00111110
Const Lightgreen = &B01111100
Const Darkgreen = &B00010100
Const Darkred = &B10100000
Const Darkblue = &B00000010
Const Brightblue = &B00011111
Const Orange = &B11111000

Dim B As Byte , Bp As Byte , C As Byte , Tmp As String * 20 , Col As Byte , Col2 As Byte
Dim Names(6) As String * 5
Names(1) = "None "
Names(2) = "Up   "
Names(3) = "Down "
Names(4) = "Right"
Names(5) = "Left "
Names(6) = "Press"

Bp = 255
C = 50
Col = 0

Glcdcmd &H25                                                'Set Contrast
Glcddata 50                                                 'value of contrast
Glcdcmd &HBF

Glcdcmd &H36                                                'Mem_control
Glcddata &B10001000                                         'My=0 Mx=0 V=1 Lao=1 Rbg=0 "00110000"
Glcdcmd &H21                                                'Inversion_on
'Glcdcmd &H20                                                'Inversion_off
Glcdcmd &H29                                                'Display On


Cls
Do
'Waitms 100

B = Joystick()
If B <> Bp Then
Bp = B

Setfont Color16x16
Lcdat 0 , 0 , Names(b) , Black , White

Setfont Color8x8
Tmp = Str(c)
Tmp = "Contrast: " + Tmp
Tmp = Tmp + "   "
Lcdat 20 , 0 , Tmp , Black , White

Tmp = Str(col)
Tmp = "Color: " + Tmp
Tmp = Tmp + "   "
Setfont Color8x8
Lcdat 30 , 0 , Tmp , Black , White

Box(66 , 40) -(132 , 132) , Col
Col2 = 255 - Col
Box(0 , 40) -(65 , 132) , Col2

End If


If B = J_up Then

Incr C
Glcdcmd &H25                                                'Set Contrast
Glcddata C                                                  'value of contrast
Glcdcmd &HBF
Setfont Color8x8
Tmp = Str(c)
Tmp = "Contrast: " + Tmp
Tmp = Tmp + "   "
Lcdat 20 , 0 , Tmp , Black , White

Elseif B = J_down Then

Decr C
Glcdcmd &H25                                                'Set Contrast
Glcddata C                                                  'value of contrast
Glcdcmd &HBF
Setfont Color8x8
Tmp = Str(c)
Tmp = "Contrast: " + Tmp
Tmp = Tmp + "   "
Lcdat 20 , 0 , Tmp , Black , White

Elseif B = J_press Then

C = 50
Col = 0
Glcdcmd &H25                                                'Set Contrast
Glcddata C                                                  'value of contrast
Glcdcmd &HBF
Setfont Color8x8
Tmp = Str(c)
Tmp = "Contrast: " + Tmp
Tmp = Tmp + "   "
Lcdat 20 , 0 , Tmp , Black , White
Tmp = Str(col)
Tmp = "Color: " + Tmp
Tmp = Tmp + "   "
Setfont Color8x8
Lcdat 30 , 0 , Tmp , Black , White
Box(66 , 40) -(132 , 132) , Col
Col2 = 255 - Col
Box(0 , 40) -(65 , 132) , Col2

Elseif B = J_right Then

Incr Col
Tmp = Str(col)
Tmp = "Color: " + Tmp
Tmp = Tmp + "   "
Setfont Color8x8
Lcdat 30 , 0 , Tmp , Black , White
Box(66 , 40) -(132 , 132) , Col
Col2 = 255 - Col
Box(0 , 40) -(65 , 132) , Col2

Elseif B = J_left Then

Decr Col
Tmp = Str(col)
Tmp = "Color: " + Tmp
Tmp = Tmp + "   "
Setfont Color8x8
Lcdat 30 , 0 , Tmp , Black , White
Box(66 , 40) -(132 , 132) , Col
Col2 = 255 - Col
Box(0 , 40) -(65 , 132) , Col2

End If
Waitms 100
Loop
End

Function Joystick() As Byte
Local Ad As Word
Ad = Getadc(j_channel)
Select Case Ad
   Case 900 To 1023 : Joystick = J_none
   Case 600 To 899 : Joystick = J_press
   Case 400 To 599 : Joystick = J_right
   Case 200 To 399 : Joystick = J_down
   Case 100 To 199 : Joystick = J_left
   Case 0 To 99 : Joystick = J_up
End Select
End Function

$include "color16x16.font"
$include "color8x8.font" 